import array
from ola.ClientWrapper import ClientWrapper
from math import pi, sqrt, exp

def gauss(n=23,sigma=1, scale=255):
    r = range(-int(n/2),int(n/2)+1)
    return [int(scale / (sigma * sqrt(2*pi)) * exp(-float(x)**2/(2*sigma**2))) for x in r]

def DmxSentCallback(state):
  if not state.Succeeded():
    wrapper.Stop()

def clamp(x):
  if x < 0:
    return 0 
  if x > 255:
    return 255
  return x

# for ola
wrapper = None
universe = 0
TICK_INTERVAL = 40  # in ms

# settings
channels = 16
gauss_width = 41
gauss_distance = 6
sigma = 5.8 

# global variables
posi = 0
# prepare arrays
dmx_data = array.array('B',(0,)*(channels*3)) # dmx-data
wa = array.array('B',(0,)*(channels*gauss_distance + 2*gauss_width)) # intermediate data with gauss-dist



def SendDMXFrame():
  # schdule a function call in 100ms
  # we do this first in case the frame computation takes a long time.
  wrapper.AddEvent(TICK_INTERVAL, SendDMXFrame)

  # copy gauss-distribution into context
  global posi
  global wa
  posi += 1
  for i in range(0,gauss_width):
    wa[posi + i] = gauss_dist[i]

  if posi >= (channels*gauss_distance + gauss_width):
    posi = 0

  # copy value 
  global dmx_data
  for i in range(0,channels):
    pick_value = wa[gauss_width+i*gauss_distance]
    green = clamp(255 - pick_value)
    blue = clamp(0)
    red = clamp(255)

    dmx_data[i*3+2] = red
    dmx_data[i*3+0] = green
    dmx_data[i*3+1] = blue
  

  # send data to dmx
  wrapper.Client().SendDmx(universe, dmx_data, DmxSentCallback)
                                                                                                                        
#
# main program starts here
#

# precalculate gauss distribution
j = 3550
gauss_dist = gauss(gauss_width,sigma,j)
while gauss_dist[gauss_width/2 + 1] < 240:
  j+=10
  gauss_dist = gauss(gauss_width,sigma,j)
print gauss_dist
print j

# start wrapper with callbacks
wrapper = ClientWrapper()
wrapper.AddEvent(TICK_INTERVAL, SendDMXFrame)
wrapper.Run()
